with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IDOMDocumentType_Interface is

   procedure Initialize (This : in out IDOMDocumentType_Type) is
   begin
      Set_IID (This, IID_IDOMDocumentType);
   end Initialize;

   function Pointer (This : IDOMDocumentType_Type)
     return Pointer_To_IDOMDocumentType
   is
   begin
      return To_Pointer_To_IDOMDocumentType (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDOMDocumentType_Type;
                     Pointer : in     Pointer_To_IDOMDocumentType)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   function Get_name
     (This : IDOMDocumentType_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_name
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_name;

   function Get_entities
     (This : IDOMDocumentType_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_entities
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_entities;

   function Get_notations
     (This : IDOMDocumentType_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_notations
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_notations;

   function Get_publicId
     (This : IDOMDocumentType_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_publicId
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_publicId;

   function Get_systemId
     (This : IDOMDocumentType_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_systemId
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_systemId;

   function Get_internalSubset
     (This : IDOMDocumentType_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_internalSubset
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_internalSubset;

end MSHTML.IDOMDocumentType_Interface;

